#!/bin/bash

# Request address
versionNumber=''
downloadLink=''

# Report update switch
reportUpdate='true'
reportUpdateApiAddress=''

gettingInformation()
{
	versionNumber=$(curl -s $versionNumber)
	downloadLink=$(curl -s $downloadLink)
}

getcurrentVersion()
{
	if [[ ! -e "/usr/bin/v2ray/v2ray" ]];then
		echo "没有检测到v2ray服务端."
		exit
	fi
	
	currentVersion=$(/usr/bin/v2ray/v2ray --version | grep "linux/amd64" | awk '{print $2}')
}

performTheUpdateProcedure()
{
	# stop v2ray service
	echo "(1/7) 正在停止 v2ray 服务..."
	systemctl stop v2ray
	
	# download the new version file
	echo "(2/7) 正在下载新版本文件..."
	wget -q -P /root "$downloadLink"
	if [[ $? != "0" ]];then
		reportUrl="${reportUpdateApiAddress}?VersionInUse=${currentVersion}&updatedVersion=${versionNumber}&executiveFeedback=failed"
		curl -s "$reportUrl" > /dev/null
		echo "文件下载失败,退出更新程序."
		exit
	fi
	unzip -q $versionNumber.zip -d /root/updateFileTemporaryDirectory
	
	# delete old files
	echo "(3/7) 正在删除旧文件..."
	rm -rf /usr/bin/v2ray/v2ray /usr/bin/v2ray/v2ctl
	
	# update new files
	echo "(4/7) 正在更新新文件..."
	cp /root/updateFileTemporaryDirectory/v2ray /usr/bin/v2ray/v2ray
	cp /root/updateFileTemporaryDirectory/v2ctl /usr/bin/v2ray/v2ctl
	
	# Delete temporary directories and files
	echo "(5/7) 正在删除暂存目录及文件..."
	rm -rf /root/updateFileTemporaryDirectory
	rm -rf "$versionNumber".zip
	
	# start v2ray service
	echo "(6/7) 正在启动 v2ray 服务..."
	systemctl start v2ray
	
	# report update log
	echo "(7/7) 正在上报更新日志..."
	if [[ "$reportUpdate" = "true" ]];then
		reportUrl="${reportUpdateApiAddress}?VersionInUse=${currentVersion}&updatedVersion=${versionNumber}&executiveFeedback=successful"
		curl -s "$reportUrl" > /dev/null
	else
		echo "上报功能已关闭,跳过."
	fi
	
	echo "更新程序执行完毕."
}

judgmentUpdate()
{
	if [[ "$versionNumber" = "$currentVersion" ]];then
		echo "版本号相同,无需更新."
	else
		echo "当前版本为${currentVersion},检测到新版本${versionNumber}"
		performTheUpdateProcedure
	fi
}

setScheduledTasks()
{
	crontab -l > /root/crontab.now
	echo "0 * * * * /bin/bash /root/automaticUpdate.sh" >> /root/crontab.now
	crontab /root/crontab.now
	rm -rf /root/crontab.now
}

if [[ "$1" = "setScheduledTasks" ]];then
	setScheduledTasks
	echo "定时任务设置完成."
else
	gettingInformation
	getcurrentVersion
	judgmentUpdate
fi

# END 2020-06-04